<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header class="m-2">
      <mat-card-title>
        <div class="flex">
          <button class="secondary-icon mr-3" (click)="back()"><mat-icon>keyboard_backspace</mat-icon></button>
        {{ name || "New Social Login" }}</div>
      </mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="socialLoginForm">
        <mat-form-field class="w-full">
          <mat-label>Social Login Provider</mat-label>
          <input matInput formControlName="name" required>
          <mat-checkbox formControlName="isDisabled" matSuffix class="client-checkboxes">Disable Social Login</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Description</mat-label>
          <input matInput formControlName="description">
          <mat-checkbox formControlName="isUserCreationDisabled" matSuffix class="client-checkboxes">Disable User Creation</mat-checkbox>
        </mat-form-field>
        <mat-form-field *ngIf="uuid" class="w-full">
          <mat-label>Redirect URL</mat-label>
          <input matInput formControlName="redirectURL" readonly>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Client ID</mat-label>
          <input matInput formControlName="clientId" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Client Secret</mat-label>
          <input matInput formControlName="clientSecret"
            [type]="hideClientSecret ? 'password' : 'text'">
          <mat-icon matSuffix (click)="hideClientSecret = !hideClientSecret">{{hideClientSecret ? 'visibility_off' :
            'visibility'}}</mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Authorization URL</mat-label>
          <input matInput formControlName="authorizationURL" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Token URL</mat-label>
          <input matInput formControlName="tokenURL" required>
          <mat-checkbox formControlName="clientSecretToTokenEndpoint" matSuffix>Requires Client Secret</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Introspection URL</mat-label>
          <input matInput formControlName="introspectionURL">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Base URL</mat-label>
          <input matInput formControlName="baseURL">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Profile URL</mat-label>
          <input matInput formControlName="profileURL" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Revocation URL</mat-label>
          <input matInput formControlName="revocationURL">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Email Attribute</mat-label>
          <input matInput formControlName="emailAttribute">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Phone Attribute</mat-label>
          <input matInput formControlName="phoneAttribute">
        </mat-form-field>
        <div *ngFor="let scp of socialLoginForm.get('scope')['controls']; let i = index;" formArrayName="scope">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2">
              <mat-label>Scope {{i+1}}</mat-label>
              <input matInput formControlName="scope">
              <button mat-icon-button color="accent" matSuffix (click)="removeScope(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addScope()">
          Add Scope<mat-icon>add</mat-icon>
        </button>
        <mat-form-field class="w-full">
          <mat-label>Claim Scope</mat-label>
          <mat-select  formControlName="claimsScope">
            <mat-option *ngFor="let claimsScope of claimsScopeList" [value]="claimsScope.name">
              {{ claimsScope.name }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <div *ngFor="let scp of socialLoginForm.get('claimsMap')['controls']; let i = index;" formArrayName="claimsMap">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2 pr-3">
              <mat-label>Claim</mat-label>
              <input matInput formControlName="claim" >
            </mat-form-field>
            <mat-form-field class="w-1/2">
              <mat-label>Map To</mat-label>
              <input matInput formControlName="mapTo" >
              <button mat-icon-button color="accent" matSuffix (click)="removeClaim(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addClaim()">
          Add Claim<mat-icon>add</mat-icon>
        </button>
      </form>
    </mat-card-content>
    <mat-card-actions class="m-4 flex flex-row gap-2">
      <button (click)="createSocialLogin()" mat-flat-button color="primary" [disabled]="!socialLoginForm.valid"
        *ngIf="!uuid">Create</button>
      <button (click)="updateSocialLogin()" mat-flat-button color="primary" [disabled]="!socialLoginForm.valid"
        *ngIf="uuid">Update</button>
      <button (click)="delete()" mat-flat-button color="warn" *ngIf="uuid && uuid !== new">Delete</button>
    </mat-card-actions>
  </mat-card>
</div>